<?php

// QuickTicket 2.1 build:20090411

function HtmlHead($strRoot='',$strSkin='',$arrCss=null,$strHeadScript='',$bJava=true,$intBbc=0,$bIE=false)
{

if ( !is_array($arrCss) ) $arrCss=array();
if ( empty($strSkin) ) $strSkin = $_SESSION[QT]['skin_dir'];

echo QTI_HTML_DTD,'
<html xmlns="http://www.w3.org/1999/xhtml" dir="',QTI_HTML_DIR,'" xml:lang="',QTI_HTML_LANG,'">
<head>
<title>',$_SESSION[QT]['site_name'],'</title>
<meta http-equiv="content-type" content="text/html; charset=',QTI_HTML_CHAR,'"/>
<link rel="shortcut icon" href="',$strRoot,$strSkin,'/qti_icon.ico"/>
<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/qti_main.css" title="cssmain"/>
';

foreach($arrCss as $strCss)
{
  echo '<link rel="stylesheet" type="text/css" href="',$strRoot,$strSkin,'/',$strCss,'" title="cssmain"/>',N;
}

if ( !empty($strHeadScript) ) echo $strHeadScript;

if ( $intBbc>0 && $_SESSION[QT]['bbc']!='0' )
{
echo '<script type="text/javascript">
<!--
';
include($strRoot.'bin/qti_j_bbc.js');
echo '
-->
</script>
';
}
if ( $bJava )
{
echo '<script type="text/javascript">
<!--
';
include($strRoot.'bin/qti_j_common.js');
echo '
-->
</script>
';
}

if ( $bIE ) echo '<!--[if IE 5]><style type="text/css">div.code{width:500px} .upper{text-transform:none;}</style><![endif]-->
<!--[if IE 6]><style type="text/css">div.code{width:500px} .upper{text-transform:none;}</style><![endif]-->
';

echo '
</head>
';

}

// --------

function HtmlPageCtrl($intType=0,$strWidth='')
{

if ( empty($strWidth) ) $strWidth=$_SESSION[QT]['site_width'];
switch ($intType)
{
case 0: echo '
<!-- PAGE CONTROL -->
<div class="qti_page">
<table class="qti_page" width="',$strWidth,'" cellspacing="0" cellpadding="0"><tr class="qti_page"><td class="qti_page">
<!-- PAGE CONTROL -->
';
break;
case 1: echo '
<!-- END PAGE CONTROL -->
</td></tr></table>
</div>
<!-- END PAGE CONTROL -->
';
break;
}

}

// --------

function HtmlBanner($intType=0,$strSkin='',$strLogo='',$strLangMenu='')
{

if ( empty($strSkin) ) $strSkin=$_SESSION[QT]['skin_dir'];
if ( empty($strLogo) ) $strLogo='qti_logo.gif';

switch ($intType)
{
case 0: echo '
<!-- HEADER BANNER -->
<div class="banner"><div class="banner_in">
<table class="hidden" cellspacing="0"><tr class="hidden">
<td class="hidden" id="banner_zl"><img id="banner_logo" src="',$strSkin,'/',$strLogo,'" alt="',$_SESSION[QT]['site_name'],'" title="',$_SESSION[QT]['site_name'],'"/></td>
<td class="hidden" id="banner_zr">',$strLangMenu,'</td>
</tr></table></div></div>
<!-- END HEADER BANNER -->
';
break;
case 1: echo '
<!-- HEADER NOBANNER -->
<table class="hidden" cellspacing="0"><tr class="hidden">
<td id="nobanner_zl">&nbsp;</td>
<td id="nobanner_zr">&nbsp;',$strLangMenu,'</td>
</tr></table>
<!-- END HEADER NOBANNER -->
';
break;
case 2: echo '
<!-- HEADER BANNER -->
<div class="banner">
<div class="banner_in">
<img src="',$strSkin,'/',$strLogo,'" width="150" height="50" style="border-width:0" alt="QuickTicket" title="QuickTicket"/>
</div>
</div>
<!-- END HEADER BANNER -->
';
break;
}

}

// --------

function HtmlPage($e=100)
{

/*
  0 BOARD OFF LINE
100 ACCESS DENIED
101 ACCESS RESTRICTED TO USERS
102 ACCESS RESTRICTED TO STAFF
*/

global $oVIP,$L,$oSYS;
include('qti_p_header.php');

switch($e)
{
case 0:
  $strFile = $_SESSION[QT]['language'].'/sys_offline.txt';
  if ( file_exists($strFile) ) { include($strFile); } else { echo '<h1>Board off-line</h1><p>The administrator has turned this board off-line.<br/>Please wait...</p>',"\n"; }
  break;
case 100: HtmlMsg(0); echo $L['E_access']; HtmlMsg(1); break;
case 101: HtmlMsg(0); echo $L['R_member']; HtmlMsg(1); break;
case 102: HtmlMsg(0); echo $L['R_staff'];  HtmlMsg(1); break;
default: echo '<p>Unknown trouble ['.strval($e).']</p>';
}

include('qti_p_footer.php');
exit;

}

// --------

function HtmlMsg($intType=0,$strWidth='',$strTitleId='',$strTitle='!',$strBodyId='',$strBody='')
{

if ( empty($strWidth) ) $strWidth='350px';

switch ($intType)
{
case 0: echo '
<div class="msgbox" style="width:',$strWidth,'">
<div class="msgboxtitle"',(empty($strTitleId) ? '' : ' id="'.$strTitleId.'"'),'>',$strTitle,'</div>
<div class="msgboxbody"',(empty($strBodyId) ? '' : ' id="'.$strBodyId.'"'),'>',(empty($strBody) ? '' : $strBody),'
';
break;
case 1: echo '
</div>
</div>
';
break;
}

}

// --------

function HtmlTabs($arrTabs=array(0=>'Empty'),$strUrl='', $strCurrent='',$intMax=6,$bFirst=true,$bLast=true,$strWarning='Data not yet saved. Quit without saving?')
{

// tabx means the last tab (can be special due to popup)
// if defined, the class/style tab_on replaces the class/style tab (but you can cumulate the classes in the definition)
// if defined, the class/style tabx_on replaces the class/style tabx (but you can cumulate the styles in the definition)
// When strCurrent is defined, this tab will not be clickable
// $arrTabs can be an array of: strings, arrays, cTab


$iCurrent=1;
foreach(array_keys($arrTabs) as $strKey)
{
  if ($strKey==$strCurrent) break;
  $iCurrent++;
}

// check

if ( !is_array($arrTabs) ) die('HtmlTabs: Argument #1 must be an array');
if ( !empty($strUrl) ) { if ( !strstr($strUrl,'?') ) $strUrl .= '?'; }

// display

echo'
<!-- tab header begin -->
<table cellspacing="0" class="tab">
';

$strOuts=''; $strOut=''; $intRow=0; $intCol=0;
foreach($arrTabs as $strKey=>$oTab)
{
  if ( $intCol==0 )
  {
    $strOut = '<tr class="tab">'."\n";
    if ( $bFirst ) $strOut .= '<td class="tab '.($intRow==0 ? 'tab_begin' : 'tab_hidden').'">&nbsp;</td>'."\n";
    $intCol++;
  }
  if ( $intCol>0 )
  {
    $strTab = '';
    $strTabDesc = '';
    // extract name and description from the object in arrTabs: can be a string, an array or a cTab
    if ( is_string($oTab) )
    {
      $strTab = $oTab;
    }
    elseif ( is_array($oTab) )
    {
      if ( isset($oTab['tabdesc']) )
      {
        if ( !empty($oTab['tabdesc']) ) $strTabDesc = $oTab['tabdesc'];
      }
      if ( isset($oTab['tabname']) )
      {
        if ( !empty($oTab['tabname']) ) { $strTab=$oTab['tabname']; } else { $strTab=ObjTrans('tab',$strKey); }
      }
      else
      {
        $strTab=ObjTrans('tab',$strKey);
      }
    }
    elseif ( strtolower(get_class($oTab))=='ctab' )
    {
      $strTabDesc = $oTab->tabdesc;
      $strTab = $oTab->tabname; if ( empty($strTab) ) $strTab = $oTab->tabid;
    }
    else
    {
      die('HtmlTabs: Arg #1 must be an array of strings, arrays or cTab');
    }
    $strOut .= '<td class="tab tab_'.($strCurrent==$strKey ? 'on' : 'off').'_l">&nbsp;</td>';
    $strOut .= '<td class="tab tab_'.($strCurrent==$strKey ? 'on' : 'off').'_c">';
    if ( empty($strUrl) || $strCurrent==$strKey )
    {
    $strOut .=  $strTab;
    }
    else
    {
    $strOut .=  '<a class="tab" href="'.$strUrl.'&amp;tt='.$strKey.'"'.(empty($strTabDesc) ? '' : ' title="'.$strTabDesc.'"').' onclick="return qtEdited(bEdited,\''.$strWarning.'\');">'.$strTab.'</a>';
    }
    $strOut .= '</td>';
    $strOut .= '<td class="tab tab_'.($strCurrent==$strKey ? 'on' : 'off').'_r">&nbsp;</td>'."\n";
    $intCol++; 
  }
  if ( $intCol>$intMax || $intCol>count($arrTabs) )
  {
    if ( $bLast ) $strOut .= '<td class="'.($intRow==0 ? 'tab tab_end' : 'hidden').'">&nbsp;</td>'."\n";
    $strOut .= '</tr>'."\n";
    $intCol=0;
    $strOuts = $strOut.$strOuts;
    $intRow++;
  }
}
if ( $intCol>0 )
{
  while($intCol<=$intMax) { $strOut .= '<td class="tab tab_a">&nbsp;</td>'; $intCol++; }
  if ( $bLast ) $strOut .= '<td class="tab'.($intRow==0 ? ' tab_end' : ' tab_hidden').'">&nbsp;</td>'."\n";
  $strOut .= '</tr>';
  $strOuts = $strOut.$strOuts;
}
echo $strOuts;

echo '
</table>
<!-- tab header end -->
';

}

// --------

function TableHeader($arrFields,$intCount=0,$strUrl='',$strOrder='lastpostdate',$strDir='',$strClass='th_t')
{

/**
 * TableHeader
 *
 * @arrField array(Sortable,Text,Class,Style)
 * @intCount number of row (if <=2, columns are not sortable)
 * @strOrder initial order field
 * @strDirec initial order direction
 * @strUrl   sorting url (without order nor dir arguments)
 */

$arrSortable = array('icon'=>'ASC','status'=>'ASC','numid'=>'DESC','title'=>'ASC','forum'=>'DESC','sectiontitle'=>'ASC','name'=>'ASC','role'=>'ASC','location'=>'ASC','firstdate'=>'DESC','firstpostname'=>'ASC','lastpostdate'=>'DESC','replies'=>'DESC','views'=>'DESC','id'=>'ASC','numpost'=>'DESC','wisheddate'=>'DESC');
if ( empty($strDir) ) $strDir=$arrSortable[$strOrder];
$img['ASC'] = ' <img class="ico i_sort" src="'.$_SESSION[QT]['skin_dir'].'/sort_asc.gif" alt="+"/>';
$img['DESC']= ' <img class="ico i_sort" src="'.$_SESSION[QT]['skin_dir'].'/sort_desc.gif" alt="-"/>';
foreach($arrFields as $strKey=>$arrVal)
{
  if ( !isset($arrVal['sort']) ) $arrVal['sort']=FALSE;
  if ( !isset($arrVal['text']) ) $arrVal['text']=S;
  if ( !isset($arrVal['thclass']) ) $arrVal['thclass']='';
  if ( !isset($arrVal['thstyle']) ) $arrVal['thstyle']='';
  if ( $arrVal['sort'] && $intCount>2 ) $arrVal['text'] = '<a href="'.$strUrl.'&amp;order='.$strKey.'&amp;dir='.($strOrder==$strKey ? QTinvert($strDir) : $arrSortable[$strKey]).'" class="'.$arrVal['thclass'].'">'.$arrVal['text'].'</a>'.($strOrder==$strKey ? $img[$strDir] : '');
  echo '<td',(empty($arrVal['thclass']) ? '' : ' class="'.$arrVal['thclass'].'"'),(empty($arrVal['thstyle']) ? '' : ' style="'.$arrVal['thstyle'].'"'),'>',$arrVal['text'],'</td>',N;
}

}

// ----------------

function TableRow($arrFields,$row,$bTopic=false,$oSEC,$strAlt='r1',$strExtra='N',$bMap=false)
{

// SETUP
  
global $oVIP,$oSYS,$L; if ( $bMap ) global $arrMapPoints;
if ( $bTopic ) $oTopic = new cTopic($row);
if ( isset($arrFields['numid']) ) { $strSectionNumfield='N'; if ( isset($oSEC) ) $strSectionNumfield=$oSEC->numfield; if ( isset($row['numfield']) ) $strSectionNumfield=$row['numfield']; }
if ( isset($arrFields['smile']) ) { $strSectionPrefix=''; if ( isset($oSEC) ) $strSectionPrefix=$oSEC->prefix; if ( isset($row['prefix']) ) $strSectionPrefix=$row['prefix']; }
if ( isset($arrFields['you']) ) { if ( $oTopic->replies>0 && $oVIP->numpost>0 && $oVIP->id>0 ) { global $oDB2; $oDB2->Query('SELECT count(id) as countid FROM '.TABPOST.' WHERE topic='.$oTopic->id.' AND userid='.$oVIP->id); $row2 = $oDB2->Getrow();   if ( $row2['countid']!=0 ) $oTopic->youreply = '<span title="'.$L['You_reply'].'"><b>&reg;</b></span>'; } }
if ( isset($arrFields['sectiontitle']) ) { if ( isset($oSYS->sections[$oTopic->section]) ) { $strSectiontitle = $oSYS->sections[$oTopic->section]; } else { $strSectiontitle='untitled'; } }
if ( isset($arrFields['tags']) )
{
  $strTags = '';
  $strAbbr = '';
  if ( empty($oTopic->tags) ) { $arrTags=array(); } else { $arrTags=explode(';',$oTopic->tags); }
  if ( count($arrTags)>1 )
  {
    for ($i=0;$i<count($arrTags);$i++)
    {
      if ( $i<3 ) $strTags .= $arrTags[$i].';';
      if ( $i>=3 ) $strAbbr .= $arrTags[$i].';';
      if ( $i>13 ) break;
    }
  }
  else
  {
    $strTags = $oTopic->tags;
  }
  $strTags = str_replace(';',' ',$strTags.(empty($strAbbr) ? '' : '<abbr title="'.$strAbbr.'">...</abbr>'));
}
// when searching in posts without title, use this to report empty title
if ( isset($arrFields['title']) )
{
  if ( trim($oTopic->title)=='' ) $oTopic->title='('.strtolower($L['Reply']).')';
  if ( empty($oTopic->title) && $oTopic->title!='0' ) $oTopic->title='('.strtolower($L['Reply']).')';
}

// icon
if ( isset($arrFields['icon']) )
{
  if ( $oTopic->type=='A' )
  {
    $strTicon = $_SESSION[QT]['skin_dir'].'/ico_topic_a_0.gif';
    $strTname = $L['Ico_topic_a_0'];
  }
  else
  {
    if ( isset($oSYS->statuses[$oTopic->status]['statusname']) )
    {
    $strTicon = $_SESSION[QT]['skin_dir'].'/'.$oSYS->statuses[$oTopic->status]['icon'];
    $strTname = $oSYS->statuses[$oTopic->status]['statusname'];
    }
    else
    {
    $strTicon = 'admin/ico_status.gif';
    $strTname = 'unknown status';
    }
  }
}

// mail
if ( isset($arrFields['mail']) || isset($arrFields['location']) )
{
  $strMail = '<img class="ico i_user" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_e_0.gif" alt="mail" title="no e-mail"/>';
  if ( !empty($row['mail']) )
  {
  if ( $row['privacy']=='2' ) $strMail = AsEmails($row['mail'],$row['id'],'0','img'.(QTI_JAVA_MAIL ? 'java' : ''),false,$_SESSION[QT]['skin_dir'],'Java protected email','&nbsp;');
  if ( $row['privacy']=='1' && $oVIP->role!='V' ) $strMail = AsEmails($row['mail'],$row['id'],'0','img'.(QTI_JAVA_MAIL ? 'java' : ''),false,$_SESSION[QT]['skin_dir'],'Java protected email','&nbsp;');
  if ( $oVIP->id==$row['id'] || $oVIP->role=='A' || $oVIP->role=='M' ) $strMail = AsEmails($row['mail'],$row['id'],'0','img'.(QTI_JAVA_MAIL ? 'java' : ''),false,$_SESSION[QT]['skin_dir'],'Java protected email','&nbsp;');
  }
}
// www
if ( isset($arrFields['www']) || isset($arrFields['location']) )
{
  if ($row['www']=='')
  {
  $strWww = '<img class="ico i_user" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_w_0.gif" alt="email" title="no web site"/>';
  }
  else
  {
  $strWww = '<a href="'.$row['www'].'"><img class="ico i_user" src="'.$_SESSION[QT]['skin_dir'].'/ico_user_w_1.gif" alt="www" title="web site"/></a>';
  }
}

// map points

if ( $bMap ) {
if ( !empty($oTopic->y) && !empty($oTopic->x) ) {
  $str = AsImg($strTicon,'T',$strTname,'ico ico_t').' '.( $strSectionNumfield=='N' ? '' : sprintf($strSectionNumfield,$oTopic->numid) );
  $str .= '<p class="small">'.QTconv(substr($oTopic->title,0,50),'3',QTI_CONVERT_AMP);
  $str .= '<br/>'.$L['By'].' '.QTconv($oTopic->firstpostname).' ('.QTdatestr($oTopic->firstpostdate,'$','$',true,true).')<br/>'.LangS('Reply',$oTopic->replies);
  $str .= '<br/><a class="gmap" href="qti_topic.php?s='.$oTopic->section.'&amp;t='.$oTopic->id.'">'.$L['map']['View_ticket'].' &raquo;</a></p>';
  $oMapPoint = new cMapPoint( floatval($row['y']),floatval($row['x']),( $strSectionNumfield=='N' ? '' : sprintf($strSectionNumfield,$oTopic->numid).' ' ).substr($oTopic->title,0,25),$str );
  if ( isset($_SESSION[QT]['m_map'][$oTopic->section]['icon']) )        $oMapPoint->icon        = $_SESSION[QT]['m_map'][$oTopic->section]['icon'];
  if ( isset($_SESSION[QT]['m_map'][$oTopic->section]['shadow']) )      $oMapPoint->shadow      = $_SESSION[QT]['m_map'][$oTopic->section]['shadow'];
  if ( isset($_SESSION[QT]['m_map'][$oTopic->section]['printicon']) )   $oMapPoint->printicon   = $_SESSION[QT]['m_map'][$oTopic->section]['printicon'];
  if ( isset($_SESSION[QT]['m_map'][$oTopic->section]['printshadow']) ) $oMapPoint->printshadow = $_SESSION[QT]['m_map'][$oTopic->section]['printshadow'];
  $arrMapPoints[$oTopic->id] = $oMapPoint;
}}

// DISPLAY

switch($oSYS->output)
{

case 'screen':

  echo '<tr class="data_t ',$strAlt,'">',N;
  foreach($arrFields as $strKey=>$arrVal)
  {
    if ( !isset($arrVal['tdclass']) ) $arrVal['tdclass'] = (isset($arrVal['thclass']) ? str_replace('th_','td_',$arrVal['thclass']) : '');
    if ( !isset($arrVal['tdstyle']) ) $arrVal['tdstyle'] = (isset($arrVal['thstyle']) ? $arrVal['thstyle'] : '');
    if ( $strKey=='status' && strstr($arrVal['tdstyle'],'%bg') ) $arrVal['tdstyle'] = str_replace('%bg',$oSYS->statuses[$oTopic->status]['color'],$arrVal['tdstyle']);
    if ( $strKey=='numid' && strstr($arrVal['tdstyle'],'%bg') ) $arrVal['tdstyle'] = str_replace('%bg',$oSYS->statuses[$oTopic->status]['color'],$arrVal['tdstyle']);
    
    echo '<td',(empty($arrVal['tdclass']) ? '' : ' class="'.$arrVal['tdclass'].' '.$strAlt.'"'),(empty($arrVal['tdstyle']) ? '' : ' style="'.$arrVal['tdstyle'].'"'),'>';
    
    switch($strKey)
    {
    case 'icon': echo AsImg($strTicon,'T',$strTname,'ico i_topic','','qti_topic.php?s='.$oTopic->section.'&amp;t='.$oTopic->id); break;
    case 'numid': echo ( $strSectionNumfield=='N' ? '&nbsp;' : '<span class="span_ref">'.sprintf($strSectionNumfield,$oTopic->numid).'</span>' ); break;
    case 'smile': echo ($oTopic->smile=='00' ? S : AsImg($_SESSION[QT]['skin_dir'].'/ico_prefix_'.$strSectionPrefix.'_'.$oTopic->smile.'.gif','[o]',$L['Ico_prefix'][$strSectionPrefix.'_'.$oTopic->smile],'ico ico_prefix')); break;
    case 'title': echo ($oTopic->type=='A' ? '<span class="small">'.$L['News_stamp'].'</span>' : ''),'<a class="topic" href="qti_topic.php?s=',$oTopic->section,'&amp;t=',$oTopic->id,'"',( !empty($oTopic->preview) ? ' title="'.$oTopic->preview.'"' : ''),'>',$oTopic->title,'</a>'; break;
    case 'you':  echo $oTopic->youreply; break;
    case 'sectiontitle': echo ObjTrans('sec','s'.$oTopic->section,$strSectiontitle); break;
    case 'firstpostname': echo '<a href="qti_usr.php?id=',$oTopic->firstpostuser,'" title="',$L['Ico_user_p_1'],'" class="small">',$oTopic->firstpostname,'</a><br/>',QTdatestr($oTopic->firstpostdate,'$','$',true,true,true); break;
    case 'lastpostdate': echo QTdatestr($oTopic->lastpostdate,'$','$',true,true,true),' <a href="qti_topic.php?s=',$oTopic->section,'&amp;t=',$oTopic->id,'#p',$oTopic->lastpostid,'" title="',$L['H_Goto_message'],'">',$L['Goto_message'],'</a><br/>',strtolower($L['By']),' <a href="qti_usr.php?id=',$oTopic->lastpostuser,'" title="',$L['Ico_user_p_1'],'" class="small">',$oTopic->lastpostname,'</a>'; break;
    case 'wisheddate':  echo '<span class="small">',( !empty($oTopic->wisheddate) ? QTdatestr($oTopic->wisheddate,'$','',true,false,true) : $L['None']),'</span>'; break;
    case 'status': echo '<span class="small" title="',(empty($oTopic->statusdate) ? '' : QTdatestr($oTopic->statusdate,'d M','H:i',true,true)),'">',$oSYS->statuses[$oTopic->status]['statusname'],'</span>'; break;
    case 'tags': echo '<span class="tag small">',$strTags,'</span>'; break;
    case 'actorname': echo '<span class="small">',( $oTopic->actorid>0 ? '<a href="qti_usr.php?id='.$oTopic->actorid.'" title="'.$L['Userrole_MA'].'" class="small">'.$oTopic->actorname.'</a>' : $L['None']),'</span>'; break;
    case 'notifiedname':echo '<span class="small">',( $oTopic->notifiedid>0 ? '<a href="qti_usr.php?id='.$oTopic->notifiedid.'" title="'.$L['Userrole_UN'].'" class="small">'.$oTopic->notifiedname.'</a>' : $L['None']),'</span>'; break;
    case 'photo': echo (empty($row['photo']) ? S : AsImg(QTI_DIR_PIC.$row['photo'],'',$row['name'],'imagelist','','qti_usr.php?id='.$row['id']) ); break;
    case 'name': echo '<a href="qti_usr.php?id=',$row['id'],'">',$row['name'],'</a>'; break;
    case 'role': echo '<span class="small">',$L['Userrole'][$row['role']],'</span>'; break;
    case 'location': echo '<span class="small">',$row['location'],'</span>',(isset($arrFields['mail']) ? '' : (empty($row['location']) ? '' : '<br/>').$strMail.' '.$strWww ); break;
    case 'www': echo $strWww; break;
    case 'mail': echo $strMail; break;
    case 'firstdate': echo QTdatestr($row['firstdate'],'$','',true,false,true); break;
    default:
      echo '<span class="small">';
      if ( $bTopic )
      {
        if ( isset($oTopic->$strKey) ) echo ($oTopic->$strKey==='' ? S : $oTopic->$strKey);
      }
      elseif ( isset($row[$strKey]) )
      {
        echo ($row[$strKey]==='' ? S : $row[$strKey]);
      }
      else
      {
        echo S;
      }
      echo '</span>';
      break;
    }
    
    echo '</td>',N;
  }
  echo '</tr>',N;
  break;

case 'print':

  echo '<tr class="data_t ',$strAlt,'">',N;
  foreach($arrFields as $strKey=>$arrVal)
  {
    if ( !isset($arrVal['tdclass']) ) $arrVal['tdclass'] = str_replace('th_','td_',$arrVal['thclass']);
    if ( !isset($arrVal['tdstyle']) ) $arrVal['tdstyle'] = '';
    if ( $strKey=='status' && strstr($arrVal['tdstyle'],'%bg') ) $arrVal['tdstyle'] = str_replace('%bg',$oSYS->statuses[$oTopic->status]['color'],$arrVal['tdstyle']);
    if ( $strKey=='numid' && strstr($arrVal['tdstyle'],'%bg') ) $arrVal['tdstyle'] = str_replace('%bg',$oSYS->statuses[$oTopic->status]['color'],$arrVal['tdstyle']);
    
    echo '<td',(empty($arrVal['tdclass']) ? '' : ' class="'.$arrVal['tdclass'].' '.$strAlt.'"'),(empty($arrVal['tdstyle']) ? '' : ' style="'.$arrVal['tdstyle'].'"'),'>';
    
    switch($strKey)
    {
    case 'icon': echo AsImg($strTicon,'T',$strTname,'ico i_topic'); break;
    case 'numid': echo ( $strSectionNumfield=='N' ? '&nbsp;' : '<span class="span_ref">'.sprintf($strSectionNumfield,$oTopic->numid).'</span>' ); break;
    case 'smile': echo ($oTopic->smile=='00' ? S : AsImg($_SESSION[QT]['skin_dir'].'/ico_prefix_'.$strSectionPrefix.'_'.$oTopic->smile.'.gif','[o]',$L['Ico_prefix'][$strSectionPrefix.'_'.$oTopic->smile],'ico ico_prefix')); break;
    case 'title': echo ($oTopic->type=='A' ? '<span class="small">'.$L['News_stamp'].'</span>' : ''),$oTopic->title; break;
    case 'you':  echo $oTopic->youreply; break;
    case 'sectiontitle': echo ObjTrans('sec','s'.$oTopic->section,$strSectiontitle); break;
    case 'firstpostname': echo $oTopic->firstpostname,'<br/>',QTdatestr($oTopic->firstpostdate); break;
    case 'lastpostdate': echo QTdatestr($oTopic->lastpostdate),'<br/>',strtolower($L['By']),' ',$oTopic->lastpostname; break;
    case 'wisheddate': echo '<span class="small">',( !empty($oTopic->wisheddate) ? QTdatestr($oTopic->wisheddate,'$','') : $L['None']),'</span>'; break;
    case 'status': echo '<span class="small">',$oSYS->statuses[$oTopic->status]['statusname'],(empty($oTopic->statusdate) ? '' : '<br/>('.QTdatestr($oTopic->statusdate,'d M','$').')'),'</span>'; break;
    case 'tags': echo '<span class="tag small">',$strTags,'</span>'; break;
    case 'actorname': echo '<span class="small">',( $oTopic->actorid>0 ? $oTopic->actorname : $L['None']),'</span>'; break;
    case 'notifiedname': echo '<span class="small">',( $oTopic->notifiedid>0 ? $oTopic->notifiedname : $L['None']),'</span>'; break;
    case 'photo': echo (empty($row['photo']) ? S : AsImg(QTI_DIR_PIC.$row['photo'],'',$row['name'],'imagelist') ); break;
    case 'role': echo '<span class="small">',$L['Userrole'][$row['role']],'</span>'; break;
    case 'firstdate': echo QTdatestr($row['firstdate'],'$',''); break;
    default:
      if ( $bTopic )
      {
        if ( isset($oTopic->$strKey) ) echo ($oTopic->$strKey==='' ? S : $oTopic->$strKey);
      }
      elseif ( isset($row[$strKey]) )
      {
        echo ($row[$strKey]==='' ? S : $row[$strKey]);
      }
      else
      {
        echo S;
      }
      break;
    }
    
    echo '</td>',N;
  }
  echo '</tr>',N;
  break;

case 'csv':

  global $strCSV; // this is only for topics !!
  foreach($arrFields as $strKey=>$arrVal) {
  switch($strKey) {
    case 'csvdate': $strCSV .= ToCsv(substr($oTopic->firstpostdate,0,8)); break;
    case 'csvtime': $strCSV .= (strlen($oTopic->firstpostdate)>9 ? ToCsv(substr($oTopic->firstpostdate,9,2).':'.substr($oTopic->firstpostdate,11,2).':'.substr($oTopic->firstpostdate,13,2)) : '""'); break;
    case 'numid':   $strCSV .= ToCsv(sprintf($strSectionNumfield,$oTopic->numid)); break;
    case 'status':  $strCSV .= ToCsv($oSYS->statuses[$oTopic->status]['statusname']); break;
    case 'smile':   $strCSV .= ToCsv(($oTopic->smile=='00' ? '' : $L['Ico_prefix'][$strSectionPrefix.'_'.$oTopic->smile])); break;
    case 'title':   $strCSV .= ToCsv(($oTopic->type=='A' ? $L['News_stamp'] : '').$oTopic->title); break;
    case 'text':    $strCSV .= ToCsv((!empty($oTopic->preview) ? $oTopic->preview : '')); break;
    case 'sectiontitle': $strCSV .= ToCsv(ObjTrans('sec','s'.$oTopic->section,$strSectiontitle)); break;
    case 'firstpostname': $strCSV .= ToCsv($oTopic->firstpostname.', '.QTdatestr($oTopic->firstpostdate)); break;
    case 'lastpostdate': $strCSV .= ToCsv(QTdatestr($oTopic->lastpostdate).' '.strtolower($L['By']).' '.$oTopic->lastpostname); break;
    case 'wisheddate': $strCSV .= ( !empty($oTopic->wisheddate) ? ToCsv(QTdatestr($oTopic->wisheddate,'$','')) : ToCsv($L['None']) ); break;
    case 'status': $strCSV .= ToCsv($oSYS->statuses[$oTopic->status]);  break;
    case 'replies': $strCSV .= $oTopic->replies.';';  break;
    case 'views': $strCSV .= $oTopic->views.';';  break;
    case 'tags': $strCSV .= ToCsv(strip_tags($strTags)); break;
    case 'id': $strCSV .= $oTopic->id.';'; break;
    case 'actorname': $strCSV .= ToCsv($oTopic->actorname); break;
    case 'notifiedname': $strCSV .= ToCsv($oTopic->notifiedname); break;
    case 'uid': $strCSV .= $oTopic->id.';'; break;
  }}
  // add return at the end (instead of ;)
  if ( substr($strCSV,-1,1)==';' ) $strCSV = substr($strCSV,0,-1);
  $strCSV .= "\r\n";
  break;

}

}

?>