<?php

// QuickTicket 2.1 build:20090411

ob_start();

// --------
// INITIALISE
// --------

// check LangMenu condition

$strLangMenu = '';
if ( $_SESSION[QT]['userlang']=='1' )
{
  if ( file_exists('bin/qti_lang.php') )
  {
    include('bin/qti_lang.php');
    $strURI = QTargimplode(QTargadd(QTargexplode(),'lx'));
    $strLangMenu = '';
    foreach($arrLang as $strKey=>$arrDef)
    {
    $strLangMenu .= '<a href="'.$oVIP->selfurl.'?'.$strURI.'&amp;lx='.$strKey.'" title="'.$arrDef[1].'" class="'.($_SESSION[QT]['show_banner']=='1' ? 'banner' : 'nobanner').'">'.$arrDef[0].'</a>&nbsp;';
    }
  }
  else
  {
    $strLangMenu .= '<span class="small">missing file:bin/qti_lang.php</span>';
  }
}  

// Contrast

if ( QTI_SHOW_CONTRAST )
{
  if ( !isset($strHeadScript) ) $strHeadScript='';
  $strHeadScript .= '<link rel="alternate stylesheet" type="text/css" href="bin/css/qti_contrast.css" title="cssalternate"/>'.N.'<script type="text/javascript" src="bin/css/qti_contrast.js"></script>'.N;
  $strLangMenu .= '<a class="css-default" href="javascript:chooseStyle(\'cssalternate\',60);"><img style="width:12px;height:12px;vertical-align:middle" src="bin/css/qti_contrast.gif" title="High contrast display" alt="Contrast"/></a><a class="css-alternate" href="javascript:chooseStyle(\'cssmain\',60);"><img style="width:12px;height:12px;border-width:0;vertical-align:middle" src="bin/css/qti_contrast.gif" title="Default display" alt="Contrast"/></a>';
}

// Menus
// [h]Header [f]Footer [n]Name [u]Url [s](optional) URLs valid for this menu item

$arrMenus = array();
if ( $_SESSION[QT]['home_menu']=='1' && !empty($_SESSION[QT]['home_url']) )
{
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$_SESSION[QT]['home_name'], 'u'=>$_SESSION[QT]['home_url']);
}
$arrMenus[]=array('h'=>false,'f'=>true, 'n'=>$L['Legal'], 'u'=>'qti_privacy.php');
$arrMenus[]=array('h'=>false,'f'=>true, 'n'=>$L['FAQ'], 'u'=>'qti_faq.php');
//$arrMenus[]=array('h'=>QTI_SHOW_FAQMENU,'f'=>true, 'n'=>$L['FAQ'], 'u'=>'qti_faq.php');
$arrMenus[]=array('h'=>true, 'f'=>false,'n'=>ObjTrans('index','i',$_SESSION[QT]['index_name']), 'u'=>'qti_index.php', 's'=>'qti_index.php qti_calendar.php qti_topics.php qti_topic.php');
$arrMenus[]=array('h'=>true, 'f'=>false,'n'=>$L['Memberlist'], 'u'=>( $_SESSION[QT]['board_offline']=='1' || ($oVIP->role=='V' && $_SESSION[QT]['visitor_right']<4) ? '' : 'qti_members.php'));
if ( QTI_SIMPLESEARCH )
{
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Search'], 'u'=>( $_SESSION[QT]['board_offline']=='1' || ($oVIP->role=='V' && $_SESSION[QT]['visitor_right']<5) ? '' : 'qti_s_search.php'),'s'=>'qti_s_search.php qti_search.php');
}
else
{
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Search'], 'u'=>( $_SESSION[QT]['board_offline']=='1' || ($oVIP->role=='V' && $_SESSION[QT]['visitor_right']<5) ? '' : 'qti_search.php'),'s'=>'qti_s_search.php qti_search.php');
}
if ( CanPerform('show_stats',$oVIP->role) ) 
{
$arrMenus[]=array('h'=>false,'f'=>true, 'n'=>$L['Statistics'], 'u'=>($_SESSION[QT]['board_offline']=='1' ? '' : 'qti_stats.php'));
}
if ( $oVIP->auth )
{
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Profile'], 'u'=>($_SESSION[QT]['board_offline']=='1' ? '' : 'qti_usr.php?id='.$oVIP->id), 's'=>'qti_usr.php qti_usr_img.php.php qti_usr_sign.php qti_usr_pwd_chg.php');
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Logout'], 'u'=>'qti_usr_login.php?a=out');
}
else
{
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Register'], 'u'=>($_SESSION[QT]['board_offline']=='1' ? '' : 'qti_usr_new.php'));
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Login'], 'u'=>'qti_usr_login.php');
}

// --------
// HTML START
// --------

// ============
switch($oSYS->output)
{
case 'screen':
// ============

// check header content

$bLegend = true;
if ( $_SESSION[QT]['board_offline']=='1' ) $bLegend=false;
if ( $_SESSION[QT]['show_legend']!='1' ) $bLegend=false;
if ( !in_array($oVIP->selfurl,array('index.php','qti_index.php','qti_topics.php','qti_calendar.php','qti_topic.php','qti_search_re.php')) ) $bLegend=false;

if ( !isset($arrCss) ) $arrCss=array();
if ( isset($strHeaderAddCss) ) $arrCss[]=$strHeaderAddCss;

HtmlHead('','',$arrCss,(isset($strHeadScript) ? $strHeadScript : ''),(isset($bJava) ? $bJava : true),(isset($intBbc) ? $intBbc : 0),(isset($bIE) ? $bIE : false));

echo '
<body'.(isset($strBodyAddOnload) ? ' onload="'.$strBodyAddOnload.'"': '').(isset($strBodyAddOnunload) ? ' onunload="'.$strBodyAddOnunload.'"': '').'>
';

// PAGE

HtmlPageCtrl(0,$_SESSION[QT]['site_width']);

// BANNER

if ( $_SESSION[QT]['show_banner']=='1' ) { HtmlBanner(0,null,null,$strLangMenu); } else { HtmlBanner(1,null,null,$strLangMenu); }

// MENU LINE

echo '<!-- MENU LINE -->',N;
echo '<table class="menu" cellspacing="0">',N;
echo '<tr class="menu">',N;

// user icon
echo '<td class="menu_ico">',($oVIP->role=='V' ? AsImg($_SESSION[QT]['skin_dir'].'/ico_user_p_0.gif','-',$L['Ico_user_p_0'],'ico_user') : AsImg($_SESSION[QT]['skin_dir'].'/ico_user_p_1.gif','-',$L['Ico_user_p_1'],'ico_user')),'</td>',N;
echo '<td class="menu_sep"></td>',N;

// user name
echo '<td class="menu_usr">&nbsp;',($oVIP->role=='V' ? $L['Userrole']['V'] : $oVIP->username),'</td>',N;
echo '<td class="menu_sep"></td>',N;

$i=0;
foreach($arrMenus as $arrMenu) {
if ( $arrMenu['h'] ) {
  if ( !isset($arrMenu['s']) ) $arrMenu['s']=$arrMenu['u'];
  if ( $i!=0 ) echo '<td class="menu_sep"></td>',N;
  $i++;
  echo '<td class="menu"'.(strstr($arrMenu['s'],$oVIP->selfurl) ? ' id="menuactif"' : '').'>';
  if ( empty($arrMenu['u']) )
  {
  echo '<span class="menu_off">',$arrMenu['n'],'</span>';
  }
  else
  {
  echo '<a class="menu" href="',$arrMenu['u'],'"',($arrMenu['u']==$oVIP->selfurl ? ' onclick="return false;"' : ''),'>',$arrMenu['n'],'</a>';
  }
  echo '</td>',N;
}}

echo '</tr>
</table>
<!-- END MENU LINE -->
';

// WELCOME

$b = true;
if ( in_array($oVIP->selfurl,array('qti_usr_new.php','qti_form_reg.php','qti_cmd.php')) ) $b = false;
if ( $_SESSION[QT]['sys_welcome']=='0' ) $b = false;
if ( $_SESSION[QT]['sys_welcome']=='1' && $oVIP->auth) $b = false;
if ( $_SESSION[QT]['board_offline']=='1' ) $b = false;
if ( !file_exists($_SESSION[QT]['language'].'/sys_welcome.txt') ) $b = false;
if ( $b )
{
echo '
<!-- WELCOME -->
<table class="welcome"><tr class="welcome"><td class="welcome">
';
include($_SESSION[QT]['language'].'/sys_welcome.txt');
echo '</td></tr></table>
<!-- END WELCOME -->
';
}

// LINE START

echo '
<!-- BODY -->
<div class="body"><div class="body_in">
<!-- BODY TOP -->
<table class="body_hd" cellspacing="0">
<tr class="body_hd">
<td class="body_hd_l"><img class="body_hd_l" src="',$_SESSION[QT]['skin_dir'],'/ico_hd_left.gif" alt=""/></td>
<td class="body_hd_c"><a class="body_hd" href="qti_index.php">',ObjTrans('index','i',$_SESSION[QT]['index_name']),'</a>';

if ( isset($s) ) {
if ( is_int($s) ) {
if ( $s>=0 ) {
  echo QTI_CRUMBTRAIL,'<a class="body_hd" href="qti_topics.php?s=',$s,'"',($oVIP->selfurl=='qti_topics.php' ? ' onclick="return false;"' : ''),'>',ObjTrans('sec',"s$s",(isset($oSEC) ? $oSEC->name : $oSYS->sections[$s])),'</a>';
  if ( isset($oTopic) && isset($oSEC) )
  {
    if ( $oTopic->numid>=0 && $oSEC->numfield!='N' ) echo QTI_CRUMBTRAIL,sprintf($oSEC->numfield,$oTopic->numid);
  }
}}}

echo '</td>',N;

echo '<td class="body_hd_c" style="text-align:right">&nbsp;';

switch($oVIP->selfurl)
{
case 'qti_topics.php':
  $bShow = false;
  if ( $_SESSION[QT]['show_calendar']=='V' ) $bShow = true;
  if ( $_SESSION[QT]['show_calendar']=='U' && $oVIP->role!='V' ) $bShow = true;
  if ( $_SESSION[QT]['show_calendar']=='M' && $oVIP->role=='M' ) $bShow = true;
  if ( $oVIP->role=='A' ) $bShow = true;
  if ( $bShow )
  {
  echo '<a href="qti_calendar.php?s=',$s,'"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_f_c.gif" title="',$L['Ico_view_f_c'],'" alt="C"/></a>&nbsp;';
  }
  break;
case 'qti_calendar.php':
  echo '<img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_f_c.gif" title="',$L['Ico_view_f_c'],'" alt="C"/>&nbsp;';
  echo '<a href="qti_topics.php?s=',$s,'"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_f_n.gif" title="',$L['Ico_view_f_n'],'" alt="N"/></a>&nbsp;';
  break;
case 'qti_stats.php':
  $strURI = QTargimplode(QTargadd(QTargexplode(),'view'));
  break;
case 'qti_topic.php':
  $strURI = QTargimplode(QTargadd(QTargexplode(),'view'));

  if ( $_SESSION[QT]['viewmode']=='C' )
  {
  echo '<a href="',$oVIP->selfurl,'?',$strURI,'&amp;view=N"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_n.gif" title="',$L['Ico_view_n'],'" alt="N"/></a>&nbsp;';
  echo '<img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_c.gif" title="',$L['Ico_view_c'],'" alt="C"/>';
  }
  else
  {
  echo '<img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_n.gif" title="',$L['Ico_view_n'],'" alt="N"/>&nbsp;';
  echo '<a href="',$oVIP->selfurl,'?',$strURI,'&amp;view=C"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_c.gif" title="',$L['Ico_view_c'],'" alt="C"/></a>';
  }
  break;
case 'qti_members.php':
  if ( !empty($_SESSION[QT]['avatar']) )
  {
    if ( $_SESSION[QT]['viewmode']=='C' )
    {
    echo '<a href="qti_members.php?view=N"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_n.gif" title="',$L['Ico_view_n'],'" alt="N"/></a>&nbsp;';
    echo '<img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_c.gif" title="',$L['Ico_view_c'],'" alt="C"/>';
    }
    else
    {
    echo '<img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_n.gif" title="',$L['Ico_view_n'],'" alt="N"/>&nbsp;';
    echo '<a href="qti_members.php?view=C"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_c.gif" title="',$L['Ico_view_c'],'" alt="C"/></a>';
    }
  }
  break;
}

if ( QTI_SHOW_PRINT ) {
if ( file_exists(substr($oVIP->selfurl,0,-4).'_prt.php') ) {
  echo '&nbsp;<a href="',substr($oVIP->selfurl,0,-4),'_prt.php',(isset($strURI) ? '?'.$strURI : ''),'"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_p.gif" title="',$L['Ico_view_p'],'" alt="P"/></a>';
}}
echo '</td>',N;

echo '<td class="body_hd_r"><img class="body_hd_r" src="',$_SESSION[QT]['skin_dir'],'/ico_hd_right.gif" alt=""/></td>
</tr>
</table>
<!-- END BODY TOP -->
';

// BODY START

echo '<!-- BODY MAIN -->
<table width="100%" cellspacing="0" class="body"><tr class="body"><td class="body">
<!-- BODY MAIN -->
';


// ============
break;
case 'print':
// ============

echo QTI_HTML_DTD,'
<html xmlns="http://www.w3.org/1999/xhtml" dir="',QTI_HTML_DIR,'" xml:lang="',QTI_HTML_LANG,'">
<head>
<title>',$_SESSION[QT]['site_name'],'</title>
<meta http-equiv="content-type" content="text/html; charset=',QTI_HTML_CHAR,'"/>
<link rel="shortcut icon" href="',$_SESSION[QT]['skin_dir'],'/qti_icon.ico"/>
<link rel="stylesheet" type="text/css" href="',$_SESSION[QT]['skin_dir'],'/qti_print.css"/>',N;
if ( isset($strHeadScript) ) echo $strHeadScript,N;
echo '</head>

<body'.(isset($strBodyAddOnload) ? ' onload="'.$strBodyAddOnload.'"': '').(isset($strBodyAddOnunload) ? ' onunload="'.$strBodyAddOnunload.'"': '').'>';

// BANNER

if ( $_SESSION[QT]['show_banner']=='1' ) Htmlbanner(2,$_SESSION[QT]['skin_dir'],'qti_logo_prt.gif');

// ========
}
// ========

?>