<?php

// QuickTicket 2.1 build:20090411

session_start();
require_once('bin/qti_init.php');
if ( !$oVIP->CanAccess('MUV',4) ) HtmlPage(101);

include(Translate('qti_stat.php'));

// INITIALISE

$arrSections = GetSectionTitles($oVIP->role);

$strCSV = '';

$intYear = date('Y');
  if ( intval(date('n'))<2 ) $intYear--;
  if ( isset($_GET['year']) ) $intYear = intval($_GET['year']);

$s = -1; if ( isset($_GET['s']) ) $s = intval($_GET['s']);
if ( $s>=0 ) { $strSection = 't.forum='.$s.' AND'; } else { $strSection=''; }

$tt = 'g';
if ( isset($_GET['tt']) ) $tt = strip_tags($_GET['tt']);
if ( isset($_POST['tt']) ) $tt = strip_tags($_POST['tt']);
$bt = 'm';
if ( isset($_GET['bt']) ) $bt = strip_tags($_GET['bt']);
if ( isset($_POST['bt']) ) $bt = strip_tags($_POST['bt']);
$gr = 'a';
if ( isset($_GET['gr']) ) $gr = strip_tags($_GET['gr']);
if ( isset($_POST['gr']) ) $gr = strip_tags($_POST['gr']);
$tr = 'a';
if ( isset($_GET['tr']) ) $tr = strip_tags($_GET['tr']);
if ( isset($_POST['gr']) ) $tr = strip_tags($_POST['tr']);
$strTags = '';
if ( !empty($tag) )
{
  $arrTags = explode(';',$tag);
  $str = '';
  foreach($arrTags as $strTag)
  {
    if ( !empty($str) ) $str .= ' OR ';
    $str .= 'UPPER(t.tags) LIKE "%'.strtoupper($strTag).'%"';
  }
  if ( !empty($str) ) $strTags = ' ('.$str.') AND';
}

  // FIRST/LAST DATE

  $query = 'SELECT min(firstpostdate) as startdate, max(firstpostdate) as lastdate FROM '.TABTOPIC;
  $oDB->Query($query);
  $row = $oDB->Getrow();

  if ( empty($row['startdate']) ) $row['startdate']=strval($intYear-1).'0101';
  if ( empty($row['lastdate']) ) $row['lastdate']=strval($intYear).'1231';

  $strFirstdate = QTdatestr($row['startdate'],'$','');
  $strLastdate = QTdatestr($row['lastdate'],'$','');

  $strLastdaysago = substr($row['lastdate'],0,8);
  $strTendaysago = DateAdd($strLastdaysago,-10,'day');

$intStartyear = intval(date('Y',strtotime($row['startdate'])));
$intStartmonth = intval(date('n',strtotime($row['startdate'])));
$intEndyear = intval(date('Y'));
$intEndmonth = intval(date('n'));

$arrAllYears = array();
for ($i=$intStartyear;$i<=$intEndyear;$i++)
{
  $arrAllYears[$i]=$i;
}
$arrYears = array($intEndyear-1=>$intEndyear-1,$intEndyear=>$intEndyear);

// GLOBAL STATISTICS

include('qti_stats_gt_inc.php');

// ------
// OUTPUT
// ------

$strCSV .= '"'.($intCurrentYear-1).' '.$intCurrentYear.($s>=0 ? ' ('.$arrSections[$s].')' : '').(empty($tag) ? '' : ', '.$L['With_tag'].' '.str_replace(';',' '.$L['or'].' ',$tag)).'"<br/>';

// -----
foreach(array($intCurrentYear-1,$intCurrentYear) as $intYear) {
// -----

  // Table header

  $strCSV .= '"'.$intYear.'";';

  switch($bt)
  {
  case 'q': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"Q'.$i.'";'; } break;
  case 'm': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"'.$L['dateMM'][$i].'";'; } break;
  case 'd': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"'.QTdatestr( DateAdd($strTendaysago,$i,'day'),'d M','' ).'";'; } break;
  }
  $strCSV .= '"'.($bt=='d' ? '10 '.strtolower($L['Days']) : $L['Year']).'"<br/>';

  // Table body

  $strCSV .= '"'.$L['Topics'].'";';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) { $strCSV .= (isset($arrT[$intYear][$intBt]) ? $arrT[$intYear][$intBt] : '0').';'; }
  $strCSV .= $arrT[$intYear][$intTotBt].'<br/>';

  $strCSV .= '"'.$L['Messages'].'";';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) { $strCSV .= (isset($arrM[$intYear][$intBt]) ? $arrM[$intYear][$intBt] : '0').';'; }
  $strCSV .= $arrM[$intYear][$intTotBt].'<br/>';

  $strCSV .= '"'.$L['Users'].'";';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) { $strCSV .= (isset($arrU[$intYear][$intBt]) ? $arrU[$intYear][$intBt] : '0').';'; }
  $strCSV .= $arrU[$intYear][$intTotBt].'<br/><br/>';

// -----
}
// -----

  // Table header

  $strCSV .= '"'.$L['Trends'].'";';

  switch($bt)
  {
  case 'q': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"Q'.$i.'";'; } break;
  case 'm': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"'.$L['dateMM'][$i].'";'; } break;
  case 'd': for ($i=1;$i<=$intMaxBt;$i++) { $strCSV .= '"'.QTdatestr( DateAdd($strTendaysago,$i,'day'),'d M','' ).'";'; } break;
  }
  $strCSV .= '"'.($bt=='d' ? '10 '.strtolower($L['Days']) : $L['Year']).'"<br/>';

  // Table body

  $strCSV .= $L['Topics'].';';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
  {
    $i = 0;
    if ( isset($arrT[$intCurrentYear][$intBt]) && isset($arrT[$intCurrentYear-1][$intBt]) )
    {
      $i = $arrT[$intCurrentYear][$intBt]-$arrT[$intCurrentYear-1][$intBt];
      if ( $tr=='p' && $i!=0 )
      {
        if ( $arrT[$intCurrentYear-1][$intBt]==0 ) $arrT[$intCurrentYear-1][$intBt]=1;
        $i = intval(($i/$arrT[$intCurrentYear-1][$intBt])*100);
      }
    }
    $strCSV .= $i.';';
  }
  $i = 0;
  if ( isset($arrT[$intCurrentYear][$intTotBt]) && isset($arrT[$intCurrentYear-1][$intTotBt]) )
  {
    $i = $arrT[$intCurrentYear][$intTotBt]-$arrT[$intCurrentYear-1][$intTotBt];
    if ( $tr=='p' && $i!=0 )
    {
      if ( $arrT[$intCurrentYear-1][$intTotBt]==0 ) $arrT[$intCurrentYear-1][$intTotBt]=1;
      $i = intval(($i/$arrT[$intCurrentYear-1][$intTotBt])*100);
    }
  }
  $strCSV .= $i.'<br/>';

  $strCSV .= $L['Messages'].';';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
  {
    $i = 0;
    if ( isset($arrM[$intCurrentYear][$intBt]) && isset($arrM[$intCurrentYear-1][$intBt]) )
    {
      $i = $arrM[$intCurrentYear][$intBt]-$arrM[$intCurrentYear-1][$intBt];
      if ( $tr=='p' && $i!=0 )
      {
        if ( $arrM[$intCurrentYear-1][$intBt]==0 ) $arrM[$intCurrentYear-1][$intBt]=1;
        $i = intval(($i/$arrM[$intCurrentYear-1][$intBt])*100);
      }
    }
    $strCSV .= $i.';';
  }
  $i = 0;
  if ( isset($arrM[$intCurrentYear][$intTotBt]) && isset($arrM[$intCurrentYear-1][$intTotBt]) )
  {
    $i = $arrM[$intCurrentYear][$intTotBt]-$arrM[$intCurrentYear-1][$intTotBt];
    if ( $tr=='p' && $i!=0 )
    {
      if ( $arrM[$intCurrentYear-1][$intTotBt]==0 ) $arrM[$intCurrentYear-1][$intTotBt]=1;
      $i = intval(($i/$arrM[$intCurrentYear-1][$intTotBt])*100);
    }
  }
  $strCSV .= $i.'<br/>';

  $strCSV .= $L['Users'].';';
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
  {
    $i = 0;
    if ( isset($arrU[$intCurrentYear][$intBt]) && isset($arrU[$intCurrentYear-1][$intBt]) )
    {
      $i = $arrU[$intCurrentYear][$intBt]-$arrU[$intCurrentYear-1][$intBt];
      if ( $tr=='p' && $i!=0 )
      {
        if ( $arrU[$intCurrentYear-1][$intBt]==0 ) $arrU[$intCurrentYear-1][$intBt]=1;
        $i = intval(($i/$arrU[$intCurrentYear-1][$intBt])*100);
      }
    }
    $strCSV .= $i.';';
  }
  $i = 0;
  if ( isset($arrU[$intCurrentYear][$intTotBt]) && isset($arrU[$intCurrentYear-1][$intTotBt]) )
  {
    $i = $arrU[$intCurrentYear][$intTotBt]-$arrU[$intCurrentYear-1][$intTotBt];
    if ( $tr=='p' && $i!=0 )
    {
      if ( $arrU[$intCurrentYear-1][$intTotBt]==0 ) $arrU[$intCurrentYear-1][$intTotBt]=1;
      $i = intval(($i/$arrU[$intCurrentYear-1][$intTotBt])*100);
    }
  }
  $strCSV .= $i.'<br/>';

// Export

if ( !headers_sent() )
{
  $strCSV = str_replace('<br/>',"\r\n",$strCSV);
  header('Content-Type: text/csv; charset='.QTI_HTML_CHAR);
  header('Content-Disposition: attachment; filename="global_stat_'.$intYear.'.csv"');
}

echo $strCSV;

?>