<?php

/**
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license. If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Troubleticket
 * @package    QuickTicket
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.1 build:20090411
 * @link       http://www.qt-cute.org/doc/package/qti
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 3.0.0
 */

session_start();
require_once('bin/qti_init.php');

// INITIALISE

$oVIP->selfurl = 'qti_faq.php';
$oVIP->selfname = $L['FAQ'];

// --------
// HTML START
// --------

$bJava = false;

include('qti_p_header.php');

echo '<a id="top"></a><h1>',$oVIP->selfname,'</h1>',N;
include(Translate('qti_faq.php'));

// HTML END

include('qti_p_footer.php');

?>